function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { forwardRef } from 'react';
import Item from "./../../Item";
import GroupTitle from "./../../GroupTitle";
var itemAbsoluteStyle = {
  position: 'absolute',
  left: 0,
  right: 0
};
// 普通列表
var List = function List(_ref, ref) {
  var allowClear = _ref.allowClear,
    multiple = _ref.multiple,
    value = _ref.value,
    list = _ref.list,
    _onChange = _ref.onChange,
    wrapper = _ref.wrapper,
    layout = _ref.layout,
    checkable = _ref.checkable,
    checkbox = _ref.checkbox,
    checkboxProps = _ref.checkboxProps,
    checkboxPosition = _ref.checkboxPosition,
    height = _ref.height;
  return (
    /*#__PURE__*/
    // 滚动占位元素
    React.createElement("div", {
      ref: ref,
      style: {
        position: 'relative',
        flex: 'none',
        height: height
      }
    }, (list || []).map(function (item) {
      var _value$findIndex;
      if (item.virtualData.type === 'group') {
        return /*#__PURE__*/React.createElement(GroupTitle, {
          key: item.id || item.virtualData.index,
          anchor: item.anchor,
          title: item.name,
          description: item.description
          // Virtual style
          ,
          style: _objectSpread(_objectSpread(_objectSpread({}, item === null || item === void 0 ? void 0 : item.style), itemAbsoluteStyle), {}, {
            top: item.virtualData.top
          })
        });
      }
      return /*#__PURE__*/React.createElement(Item, _extends({
        key: item.id || item.virtualData.index
        // Custom Wrapper or Item
        ,
        wrapper: wrapper
        // Display Item
        ,
        title: item.name
        // Other Item
      }, item, {
        // Item Data
        itemData: item
        // Global Config
        ,
        layout: layout,
        checkable: checkable,
        checkbox: item.checkbox || checkbox,
        checkboxProps: multiple ? checkboxProps : _objectSpread({
          icon: 'tick'
        }, checkboxProps),
        checkboxPosition: item.checkboxPosition || checkboxPosition,
        checked: (value === null || value === void 0 || (_value$findIndex = value.findIndex) === null || _value$findIndex === void 0 ? void 0 : _value$findIndex.call(value, function (valueItem) {
          return (valueItem === null || valueItem === void 0 ? void 0 : valueItem.id) === item.id;
        })) >= 0,
        onChange: function onChange(checked) {
          var newValue = null;
          // 多选
          if (multiple) {
            if (!checked) {
              newValue = value.filter(function (valueItem) {
                return (valueItem === null || valueItem === void 0 ? void 0 : valueItem.id) !== item.id;
              });
            } else {
              newValue = [].concat(_toConsumableArray(value || []), [item]);
            }
          }
          // 单选
          else {
            if (!checked) {
              newValue = allowClear ? null : [item];
            } else {
              newValue = [item];
            }
          }
          _onChange && _onChange(newValue, {
            checked: checked,
            item: item
          });
        }
        // Virtual style
        ,
        style: _objectSpread(_objectSpread(_objectSpread({}, item === null || item === void 0 ? void 0 : item.style), itemAbsoluteStyle), {}, {
          top: item.virtualData.top
        })
      }));
    }))
  );
};
export default /*#__PURE__*/forwardRef(List);